;**********************************************************
;*        	Ex5.ASM
;*  This program is for delay subroutine test: 
;*  use the 16MHz Crystal for the system frequency;
;*  use the Stopwatch Wicdow of MPLAB SIM to measure as below delay routine 
;*  Delay   0.5mS 
;*  Delay  10.0mS
;*  Delay 200.0mS
;**********************************************************
			list p=16F877a		
			#include 	<p16f877a.inc>		; Include file locate at defult directory
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF
;
VAL_500US	equ	.250			; 0.5ms delay value
VAL_10MS	equ	.20				; 10mS delay value
VAL_200MS	equ	.20				; 200mS delay value
;
count_us	equ	0x20			; Defined temp reg. for 1ms delay
count_10ms	equ	0x21            ; Defined delay reg.
count_200ms	equ	0x22
;
;***************************************
;           Program start              *
;***************************************
			org 	0x00		; reset vector
			nop					; Reserve for MPLAB-ICD
;
;************ Main *********************
;
start:
			call	delay_500us
			call	delay_10ms
			call 	delay_200ms	 
			goto	start
;
;--------- 200 md delay routine --------
;
delay_200ms:	
			movlw	VAL_200MS		 
			movwf	count_200ms
loop_20ms	call 	delay_10ms
			decfsz	count_200ms,f
			goto	loop_20ms
			return
;
;-------- 10 ms delay routine ----------
;
delay_10ms:	
			movlw	VAL_10MS		 
			movwf	count_10ms
loop_ms		call 	delay_500us
			decfsz	count_10ms,f
			goto	loop_ms
			return
;
;-------- 0.5 ms delay routine -----------
;
delay_500us:
			movlw	VAL_500US		 		
			movwf	count_us
dec_loop	nop
			nop
			nop
			nop
			nop
			decfsz	count_us,f
			goto 	dec_loop
			return
;	
			end
