;**********************************************************
;*               Ex9.ASM
;*  This program will detect SW status to control
;*  the shift data on PORTC. 
;*  Please make sure that the DIP switch SW3 has all 
;*  switches in the ON position.
;**********************************************************
			list p=16F877a		
			#include 	<p16f877a.inc>			; Include file locate at defult directory
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF
;

#define		RA4	PORTA,4
;
SHIFT_VAL	equ	b'00000111'			; LED shift initial value
;
VAL_500US	equ	.250				; 0.5ms delay value
VAL_10MS	equ	.20					; 10mS delay value
VAL_200MS	equ	.10					; 100mS delay value
;
count_us	equ	0x20				; Defined temp reg. for 1ms delay
count_10ms	equ	0x21           	 	; Defined delay reg.
count_200ms	equ	0x22
;
;***************************************
;           Program start              *
;***************************************
			org 	0x00			; reset vector
			nop						; Reserve for MPLAB-ICD
initial:	
			clrf	PCLATH		
			banksel	TRISC			; Select to bank1
			movlw	b'00000111'		; Set PORTA & E for Digital I/O
			movwf	ADCON1
;
			clrf	TRISD			; Set PORTD for LED output	
;
			banksel PORTD 			; Select to bank0
			clrf	PORTD			; Clear PORTD
;
;************ Main *********************
;
start:
			movlw	SHIFT_VAL
			movwf	PORTD
;
test_rb0	btfss	RA4				; Check RA4 press ?
			goto	led_right		; Yes, RA4 closed, b0-->C-->b7
;
led_left	rlf		PORTD,F			; No, RA4 is open, B7-->C-->b0
			call 	delay_200ms 	; Call delay routine
			goto	test_rb0
;
led_right	rrf		PORTD,F		 
			call 	delay_200ms
			goto	test_rb0
;
;
;--------- 200 md delay routine --------
;
delay_200ms:	
			movlw	VAL_200MS		 
			movwf	count_200ms
loop_20ms	call 	delay_10ms
			decfsz	count_200ms,F
			goto	loop_20ms
			return
;
;-------- 10 ms delay routine ----------
;
delay_10ms:	
			movlw	VAL_10MS		 
			movwf	count_10ms
loop_ms		call 	delay_500us
			decfsz	count_10ms,F
			goto	loop_ms
			return
;
;-------- 0.5 ms delay routine -----------
;
delay_500us:
			movlw	VAL_500US		 		
			movwf	count_us
dec_loop	nop
			nop
			nop
			nop
			nop
			decfsz	count_us,F
			goto 	dec_loop
			return
;	
			end
